## nexus 4.3.2-svn1919

=== debian/changelog ===
nexus (4.3.2-svn1919-1) unstable; urgency=low

  * upstream: fix problem with null terminated fixed size strings in nxbrowse
  * force building with hdf5 (ubuntu managed to build without)

 -- Tobias Stefan Richter <tsr-debian@achos.com>  Wed, 13 Nov 2013 14:36:50 +0000

nexus (4.3.2-svn1915-1) unstable; urgency=low

  * new upstream snapshot
  * better support from compression from Java
  * bug fixes

 -- Tobias Stefan Richter <tsr-debian@achos.com>  Sat, 14 Sep 2013 18:19:10 +0100
